/****************         MOUNTAIN RANGES           ****************/

#include <stdio.h>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <stdlib.h>
#include <math.h>
#define N 6    /** 2*N=length of a mountain range.    May be changed  */
#define pas 7
void drawing(void);
void pause(void);
void putpixel(int xe, int ye, Uint32 couleur);
Uint32 getpixel(int xe, int ye);
void line(int x0,int y0, int x1,int y1, Uint32 c);
void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c);
SDL_Surface * screen; Uint32 white, color[2];
SDL_Surface *texte;  SDL_Rect position;TTF_Font *police=NULL;char chiffre[2000];
int a[2*N],n,xorig,yorig;

int main(int argc, char ** argv)
{ int i,j,k,pospivot,count0;
   SDL_Init(SDL_INIT_VIDEO);
   screen=SDL_SetVideoMode(800,600,32, SDL_HWSURFACE|SDL_DOUBLEBUF);
   white=SDL_MapRGB(screen->format,255,255,255);
   color[0]=SDL_MapRGB(screen->format,0,0,0);
   color[1]=SDL_MapRGB(screen->format,0,0,255);
   SDL_FillRect(screen,0,white);
   TTF_Init();  police=TTF_OpenFont("times.ttf",20); SDL_Color couleurnoire={0,0,0};
   xorig=10;yorig=pas*N+10;  n=0;
   for(i=0;i<2*N;i++)
   if (i<N) a[i]=0; else a[i]=1;
   for(;;)
     { drawing(); n++;
        i=2*N-1;count0=0;
       while (i>=2 && !(a[i]==1 && a[i-1]==1 && a[i-2]==0))
          { if (a[i]==0) count0++;   i--;
          }
       pospivot=i-2;  if (pospivot==-1) break;
       a[pospivot]=1; a[pospivot+1]=0;
       k=0;
       for(j=pospivot+2;j<2*N;j++)
         { if (k<count0) a[j]=0; else a[j]=1;
            k++;
         }
     }
   sprintf( chiffre," %d  mountaain ranges of length %d",n,2*N);
   texte=TTF_RenderText_Solid(police,chiffre,couleurnoire);
   position.x=10;position.y=550;
   SDL_BlitSurface(texte,NULL,screen,&position);
   SDL_Flip(screen);  pause();TTF_CloseFont(police); TTF_Quit();  return 0;
}

void drawing(void)
{ int i; int x,y,oldx,oldy;
   x=xorig;y=yorig;
   for(i=0;i<2*N;i++)
     { oldx=x;oldy=y;
        x+=pas;
        if (a[i]==0) y-=pas;
        else y+=pas;
        linewithwidth(oldx,oldy,x,y,1,color[1]); linewithwidth(x,y,x,yorig,0,color[1]);
      }
   linewithwidth(xorig,yorig,xorig+2*N*pas,yorig,1,color[1]);
   xorig+=2*N*pas+10; if (xorig>810-2*N*pas) { xorig=10;yorig+=N*pas+7;}
   if (yorig>600-pas*N) { SDL_Flip(screen);  pause();
                                      SDL_FillRect(screen,0,white);  xorig=10; yorig=pas*N+10;
                                    }
}

void pause(void)
{
    SDL_Event evenement;
    do   SDL_WaitEvent(&evenement);
    while(evenement.type != SDL_QUIT && evenement.type != SDL_KEYDOWN);
}

void putpixel(int xe, int ye, Uint32 couleur)
{ Uint32 * numerocase;
numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;    *numerocase=couleur;
}

Uint32 getpixel(int xe, int ye)
{ Uint32 * numerocase;
   numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;   return (*numerocase);
}

void line(int x0,int y0, int x1,int y1, Uint32 c)
{
int dx,dy,x,y,residu,absdx,absdy,stepx,stepy,i;
dx=x1-x0; dy=y1-y0;  residu=0;       x=x0;y=y0;  putpixel(x,y,c);
if (dx>0) stepx=1;else stepx=-1; if (dy>0) stepy=1; else stepy=-1;
absdx=abs(dx);absdy=abs(dy);
if (dx==0) for(i=0;i<absdy;i++) { y+=stepy;
                                                    putpixel(x,y,c); }
else if(dy==0) for(i=0;i<absdx;i++){ x+=stepx;
                                                         putpixel(x,y,c);  }
else if (absdx==absdy)
   for(i=0;i<absdx;i++) {x+=stepx; y+=stepy;
                                     putpixel(x,y,c);
                                     }
else if (absdx>absdy)
          for(i=0;i<absdx;i++)
			  { x+=stepx; residu+=absdy;
			     if(residu >= absdx) {residu -=absdx; y+=stepy;}
			     putpixel(x,y,c);
			  }
else for(i=0;i<absdy;i++)
             {y+=stepy; residu +=absdx;
              if (residu>=absdy)   {residu -= absdy;x +=stepx;}
              putpixel(x,y,c);
             }
}

void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c)
{
int dx,dy;
float k,xf1,yf1,xf2,yf2,d,dx1,dy1,ndx1,ndy1,ndx2,ndy2,angle=M_PI/2.;
line(x1,y1,x2,y2,c);
dx=x2-x1; dy=y2-y1;       d=sqrt(dx*dx+dy*dy);
if (d!=0.)      /* si le vecteur n’est pas nul */
{ dx1=(float)epaisseur*(float)dx/d; dy1=(float)epaisseur*(float)dy/d;
   ndx1=dx1*cos(angle)-dy1*sin(angle);
   ndy1=dx1*sin(angle)+dy1*cos(angle);
   ndx2=dx1*cos(-angle)-dy1*sin(-angle);
   ndy2=dx1*sin(-angle)+dy1*cos(-angle);
   for(k=0;k<=1.;k+=0.1/d)
   {
   xf1=(1.-k)*x1+k*x2; yf1=(1.-k)*y1+k*y2;
   xf2=xf1-ndx1; yf2=yf1-ndy1;  line(xf1,yf1,xf2,yf2,c);
   xf2=xf1-ndx2; yf2=yf1-ndy2;    line(xf1,yf1,xf2,yf2,c);
   }
}
}




